<?php
/*
Plugin Name: Simple Twitter Plugin
Plugin URI: http://fornyhucker.blogspot.com/
Description: Create sidebar widget that display your most recent Twitter updates.
Version: 1.0.1
Author: Ilya Kopturov
Author URI: http://fornyhucker.blogspot.com/
License: GPL
*/

class TwitterWidget extends WP_Widget {
	/** constructor */
	function TwitterWidget() {
		$widget_ops = array( 'description' => 'Display your most recent Twitter updates' );
		parent::WP_Widget( 'twitterwidget', $name = 'Twitter Widget',  $widget_ops);
	}

	/** @see WP_Widget::widget */
	function widget( $args, $instance ) {
		extract( $args );
		echo $before_widget;
		?>
		<script src="http://widgets.twimg.com/j/2/widget.js"></script>
		<script>
		new TWTR.Widget({
		  version: 2,
		  type: 'profile',
		  rpp: 4,
		  interval: 30000,
		  width: <?php echo $instance['width']; ?>,
		  height: <?php echo $instance['height']; ?>,
		  theme: {
		    shell: {
		      background: '<?php echo $instance['shell_background']; ?>',
		      color: '<?php echo $instance['shell_color']; ?>'
		    },
		    tweets: {
		      background: '<?php echo $instance['tweets_background']; ?>',
		      color: '<?php echo $instance['tweets_color']; ?>',
		      links: '<?php echo $instance['tweets_link']; ?>'
		    }
		  },
		  features: {
		    scrollbar: false,
		    loop: false,
		    live: false,
		    hashtags: true,
		    timestamp: true,
		    avatars: false,
		    behavior: 'all'
		  }
		}).render().setUser('<?php echo $instance['twitter_username'];?>').start();
		</script>
		<?php echo $after_widget;
	}

	/** @see WP_Widget::update */
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['twitter_username'] 	= strip_tags( $new_instance[ 'twitter_username' ] );
		$instance['width']				= strip_tags( $new_instance[ 'width' ] );
		$instance['height']				= strip_tags( $new_instance[ 'height' ] );
		$instance['shell_background']	= strip_tags( $new_instance[ 'shell_background' ] );
		$instance['shell_color']		= strip_tags( $new_instance[ 'shell_color'] );
		$instance['tweets_background']	= strip_tags( $new_instance[ 'tweets_background' ] );
		$instance['tweets_color']		= strip_tags( $new_instance[ 'tweets_color' ] );
		$instance['tweets_link']		= strip_tags( $new_instance[ 'tweets_link' ] );
		return $instance;
	}

	/** @see WP_Widget::form */
	function form( $instance ) {
		if ( $instance ) {
			$twitter_username 	= esc_attr( $instance[ 'twitter_username' ] );
			$width 				= esc_attr( $instance[ 'width' ] );
		  	$height 			= esc_attr( $instance[ 'height' ] );
		  	$shell_background	= esc_attr( $instance[ 'shell_background' ] );
		    $shell_color 		= esc_attr( $instance[ 'shell_color'] );
		    $tweets_background 	= esc_attr( $instance[ 'tweets_background' ] );
		    $tweets_color 		= esc_attr( $instance[ 'tweets_color' ] );
		    $tweets_link 		= esc_attr( $instance[ 'tweets_link' ] );
		} else {
			//default options
			$twitter_username 	= 'twitter';
			$width				= '250';
			$height				= '300';
			$shell_background	= '#333333';
			$shell_color		= '#ffffff';
			$tweets_background	= '#000000';
			$tweets_color		= '#ffffff';
			$tweets_link		= '#4aed05';
		}
		?>
		<script language="javascript" type="text/javascript" src="/wp-content/plugins/simple-twitter-plugin/javascripts/mColorPicker.js"/></script>
		<p>
			<label for="<?php echo $this->get_field_id('twitter_username'); ?>"><?php _e('Twitter Username:'); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id('twitter_username'); ?>" name="<?php echo $this->get_field_name('twitter_username'); ?>" type="text" value="<?php echo $twitter_username; ?>" />
		</p>
		<table>
			<tr><td>
				<label for="<?php echo $this->get_field_id('width'); ?>"><?php _e('Block width:'); ?></label> 
				</td><td>
				<input class="widefat" size="8" id="<?php echo $this->get_field_id('width'); ?>" name="<?php echo $this->get_field_name('width'); ?>" type="text" value="<?php echo $width; ?>" />
			</td></tr>
			<tr><td>
				<label for="<?php echo $this->get_field_id('height'); ?>"><?php _e('Block height:'); ?></label> 
				</td><td>
				<input class="widefat" size="8" id="<?php echo $this->get_field_id('height'); ?>" name="<?php echo $this->get_field_name('height'); ?>" type="text" value="<?php echo $height; ?>" />
			</td></tr>
			<tr><td>&nbsp</td></tr>
			<tr><td>
				<label for="<?php echo $this->get_field_id('shell_background'); ?>"><?php _e('Shell background:'); ?></label>
				</td><td>
				<input id="<?php echo $this->get_field_id('shell_background'); ?>" name="<?php echo $this->get_field_name('shell_background'); ?>" type="color" data-text="hidden" style="height:20px;width:20px;" class="color" value="<?php echo $shell_background; ?>"/>
			</td></tr>
			<tr><td>
				<label for="<?php echo $this->get_field_id('shell_color'); ?>"><?php _e('Shell color:'); ?></label> 
				</td><td> 
				<input id="<?php echo $this->get_field_id('shell_color'); ?>" name="<?php echo $this->get_field_name('shell_color'); ?>" type="color" data-text="hidden" style="height:20px;width:20px;" class="color" value="<?php echo $shell_color; ?>" />
			</td></tr>
			<tr><td>
				<label for="<?php echo $this->get_field_id('tweets_background'); ?>"><?php _e('Tweets background:'); ?></label> 
				</td><td> 
				<input id="<?php echo $this->get_field_id('tweets_background'); ?>" name="<?php echo $this->get_field_name('tweets_background'); ?>" type="color" data-text="hidden" style="height:20px;width:20px;" class="color" value="<?php echo $tweets_background; ?>" />
			</td></tr>
			<tr><td>
				<label for="<?php echo $this->get_field_id('tweets_color'); ?>"><?php _e('Tweets color:'); ?></label> 
				</td><td> 
				<input id="<?php echo $this->get_field_id('tweets_color'); ?>" name="<?php echo $this->get_field_name('tweets_color'); ?>" type="color" data-text="hidden" style="height:20px;width:20px;" class="color" value="<?php echo $tweets_color; ?>" />
			</td></tr>
			<tr><td>
				<label for="<?php echo $this->get_field_id('tweets_link'); ?>"><?php _e('Tweets link:'); ?></label> 
				</td><td> 
				<input id="<?php echo $this->get_field_id('tweets_link'); ?>" name="<?php echo $this->get_field_name('tweets_link'); ?>" type="color" data-text="hidden" style="height:20px;width:20px;" class="color" value="<?php echo $tweets_link; ?>" />
			</td></tr>
		</table>
		<?php 
	}

} // class TwitterWidget

function TwitterWidget_init()
{	
	add_action( 'widgets_init', create_function( '', 'return register_widget("TwitterWidget");' ) );
}

add_action("plugins_loaded", "TwitterWidget_init");
?>
